extend("fiskheroes:hero_basic");
loadTextures({
    "layer1": "smp:redstonemech_layer1",
    "layer2": "smp:redstonemech_layer2",
    "lights1": "smp:redstonemech_light_layer1",
    "lights2": "smp:redstonemech_light_layer2"
});

var utils = implement("fiskheroes:external/utils");
var boosters = implement("smp:external/redstone_mech_boosters");

var booster;

function init(renderer) {
    parent.init(renderer);
    renderer.setTexture((entity, renderLayer) => {
        return renderLayer == "LEGGINGS" ? "layer2" : "layer1";
    });
    renderer.setLights((entity, renderLayer) => {
        return renderLayer == "LEGGINGS" ? "lights2" : "lights1";
    });
}

function initEffects(renderer, entity) {
    boosters = boosters.create(renderer, "fiskheroes:red_fire_layer_%s", true);

    utils.addCameraShake(renderer, 0.015, 1.5, "fiskheroes:flight_boost_timer");

    utils.bindBeam(renderer, "fiskheroes:repulsor_blast", "fiskheroes:repulsor_blast", "rightArm", 0xFFC462, [
        { "firstPerson": [-4.5, 3.75, -7.0], "offset": [-0.5, 9.0, 0.0], "size": [1.5, 1.5] }
    ]);
}

function initAnimations(renderer) {
    parent.initAnimations(renderer);
    utils.addFlightAnimationWithLanding(renderer, "iron_man.FLIGHT", "fiskheroes:flight/iron_man.anim.json");
    utils.addHoverAnimation(renderer, "iron_man.HOVER", "fiskheroes:flight/idle/iron_man");
    addAnimationWithData(renderer, "rainbow.LAND", "fiskheroes:superhero_landing", "fiskheroes:dyn/superhero_landing_timer")
        .priority = -8;

    utils.addAnimationEvent(renderer, "FLIGHT_DIVE", "fiskheroes:iron_man_dive");
    
    addAnimationWithData(renderer, "rainbow.ROLL", "fiskheroes:flight/barrel_roll", "fiskheroes:barrel_roll_timer")
            .priority = 10;
}

function render(entity, renderLayer, isFirstPersonArm) {
    boosters.render(entity, renderLayer, isFirstPersonArm, false);
}
